<?php

/*********************************************************************

 freo | 管理画面 | メディア登録 (2010/09/01)

 Copyright(C) 2009-2010 freo.jp

*********************************************************************/

/* メイン処理 */
function freo_main()
{
	global $freo;

	//ログイン状態確認
	if ($freo->user['authority'] != 'root' and $freo->user['authority'] != 'author') {
		freo_redirect('login', true);
	}

	//入力データ確認
	if (empty($_SESSION['input'])) {
		freo_redirect('admin/media?error=1' . (isset($_GET['type']) ? '&type=' . $_GET['type'] : ''));
	}

	//ワンタイムトークン確認
	if (!freo_token('check', (isset($_GET['type']) ? $_GET['type'] : null))) {
		freo_redirect('admin/media?error=1' . (isset($_GET['type']) ? '&type=' . $_GET['type'] : ''));
	}

	//入力データ取得
	$media = $_SESSION['input']['media'];

	//ファイル保存
	$file_dir = FREO_FILE_DIR . 'medias/' . ($media['directory'] ? $media['directory'] . '/' : '');

	if (!freo_mkdir($file_dir)) {
		freo_error('ディレクトリ ' . $file_dir . ' を作成できません。');
	}

	$org_media = $media['file'];

	if (rename(FREO_FILE_DIR . 'temporaries/medias/' . $media['file'], $file_dir . $media['file'])) {
		if ($freo->config['media']['filename'] and preg_match('/\.(.*)$/', $media['file'], $matches)) {
			$filename = date('YmdHis') . '.' . $matches[1];

			if (rename($file_dir . $media['file'], $file_dir . $filename)) {
				$media['file'] = $filename;
			} else {
				freo_error('ファイル ' . $file_dir . $media['file'] . ' の名前を変更できません。');
			}
		}

		chmod($file_dir . $media['file'], 0606);
	} else {
		freo_error('ファイル ' . FREO_FILE_DIR . 'temporaries/medias/' . $media['file'] . ' を移動できません。');
	}

	if ($freo->config['media']['thumbnail']) {
		$thumbnail_dir = FREO_FILE_DIR . 'media_thumbnails/' . ($media['directory'] ? $media['directory'] . '/' : '');
		$temporary_dir = FREO_FILE_DIR . 'temporaries/media_thumbnails/';

		if ($org_media and file_exists($temporary_dir . $org_media)) {
			if (!freo_mkdir($thumbnail_dir)) {
				freo_error('ディレクトリ ' . $thumbnail_dir . ' を作成できません。');
			}

			if (rename($temporary_dir . $org_media, $thumbnail_dir . $media['file'])) {
				chmod($thumbnail_dir . $media['file'], 0606);
			} else {
				freo_error('ファイル ' . $temporary_dir . $org_media . ' を移動できません。');
			}
		}
	}

	//入力データ破棄
	$_SESSION['input'] = array();

	//ログ記録
	freo_log('メディアを新規に登録しました。');

	//エントリー管理へ移動
	freo_redirect('admin/media?exec=insert' . (isset($media['directory']) ? '&directory=' . $media['directory'] : '') . (isset($_GET['type']) ? '&type=' . $_GET['type'] : ''));

	return;
}

?>
